package com.cf.imes.framework.common.validation;

import jakarta.validation.Constraint;
import jakarta.validation.Payload;
import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 自定义Integer校验注解
 *
 * @author Gqr
 * @since 2024/10/17 10:58
 */
@Target({
        ElementType.METHOD,
        ElementType.FIELD,
        ElementType.ANNOTATION_TYPE,
        ElementType.CONSTRUCTOR,
        ElementType.PARAMETER,
        ElementType.TYPE_USE
})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Constraint(
        validatedBy = NumberValidator.class
)
public @interface NumberValid {
    /**
     * 字段中文名
     *
     * @return
     */
    String name();

    /**
     * 校验提示信息
     *
     * @return
     */
    String message() default "数字不合法";

    Class<?>[] groups() default {};

    Class<? extends Payload>[] payload() default {};

    /**
     * 整数最大位数
     *
     * @return
     */
    int integer() default 5;

    /**
     * 小数点后的最大位数
     *
     * @return
     */
    int fraction() default 3;
}
